/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "advancedmonitordialogclass.h"

#include <iostream.h>


advancedMonitorDialogClass::advancedMonitorDialogClass(QWidget *parent, const char *name, QString xorgFile, int sectionNum)
    :scrAdv(parent, name)
{
sectNum = sectionNum;
x = new xorgConf();
x->saveXorg(xorgFile);
setLocale();

if (x->getOptionNoBrackets("Screen", sectNum, "DefaultFbBpp") != "") 
{
checkBox23->setChecked(TRUE);
if (x->getOptionNoBrackets("Screen", sectNum, "DefaultFbBpp") == "24") { kComboBox13->setCurrentItem(0); }
if (x->getOptionNoBrackets("Screen", sectNum, "DefaultFbBpp") == "32") { kComboBox13->setCurrentItem(1); }
}
//Init
if (x->checkOption("Screen", sectNum, "InitPrimary")) { checkBox25->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "NoInt10")) { checkBox26->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "NoMTRR")) { checkBox27->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoCPUToScreenColorExpandFill")) { checkBox28->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoColor8x8PatternFillRect")) { checkBox29->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoColor8x8PatternFillTrap")) { checkBox30->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoDashedBresenhamLine")) { checkBox31->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoDashedTwoPointLine")) { checkBox32->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoImageWriteRect")) { checkBox33->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoMono8x8PatternFillRect")) { checkBox34->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoMono8x8PatternFillTrap")) { checkBox35->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoOffscreenPixmaps")) { checkBox36->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoPixmapCache")) { checkBox37->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoScanlineCPUToScreenColorExpandFill")) { checkBox38->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoScanlineImageWriteRect")) { checkBox40->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoScreenToScreenColorExpandFill")) { checkBox41->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoScreenToScreenCopy")) { checkBox42->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoSolidBresenhamLine")) { checkBox43->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoSolidFillRect")) { checkBox44->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoSolidFillTrap")) { checkBox45->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoSolidHorVertLine")) { checkBox46->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "XaaNoSolidTwoPointLine")) { checkBox47->setChecked(TRUE); }
if (x->checkOption("Screen", sectNum, "Accel")) { checkBox24->setChecked(TRUE); }

if (x->checkOption("Screen", sectNum, "BiosLocation")) 
{
groupBox2->setChecked(TRUE);
kLineEdit1->setText(x->getOption("Screen", sectNum, "BiosLocation"));
}

x->removeOption("Screen", sectNum, "Accel");
x->removeOption("Screen", sectNum, "InitPrimary");
x->removeOption("Screen", sectNum, "NoInt10");
x->removeOption("Screen", sectNum, "NoMTRR");
x->removeOption("Screen", sectNum, "XaaNoCPUToScreenColorExpandFill");
x->removeOption("Screen", sectNum, "XaaNoColor8x8PatternFillRect");
x->removeOption("Screen", sectNum, "XaaNoColor8x8PatternFillTrap");
x->removeOption("Screen", sectNum, "XaaNoDashedBresenhamLine");
x->removeOption("Screen", sectNum, "XaaNoDashedTwoPointLine");
x->removeOption("Screen", sectNum, "XaaNoImageWriteRect");
x->removeOption("Screen", sectNum, "XaaNoMono8x8PatternFillRect");
x->removeOption("Screen", sectNum, "XaaNoMono8x8PatternFillTrap");
x->removeOption("Screen", sectNum, "XaaNoOffscreenPixmaps");
x->removeOption("Screen", sectNum, "XaaNoPixmapCache");
x->removeOption("Screen", sectNum, "XaaNoScanlineCPUToScreenColorExpandFill");
x->removeOption("Screen", sectNum, "XaaNoScanlineImageWriteRect");
x->removeOption("Screen", sectNum, "XaaNoScreenToScreenColorExpandFill");
x->removeOption("Screen", sectNum, "XaaNoScreenToScreenCopy");
x->removeOption("Screen", sectNum, "XaaNoSolidBresenhamLine");
x->removeOption("Screen", sectNum, "XaaNoSolidFillRect");
x->removeOption("Screen", sectNum, "XaaNoSolidFillTrap");
x->removeOption("Screen", sectNum, "XaaNoSolidHorVertLine");
x->removeOption("Screen", sectNum, "XaaNoSolidTwoPointLine");
x->removeOption("Screen", sectNum, "BiosLocation");
x->removeOption("Screen", sectNum, "DefaultFbBpp");





}

QString advancedMonitorDialogClass :: returnXorg()
{
return x->returnConfig();
}

void advancedMonitorDialogClass::framebufferLayoutCheckBox()
{
if (checkBox23->isChecked()) { kComboBox13->setEnabled(TRUE); }
if (!checkBox23->isChecked()) { kComboBox13->setEnabled(FALSE); }
}

void advancedMonitorDialogClass::int10Check()
{
if (checkBox25->isChecked()) { checkBox26->setChecked(FALSE); }
}

void advancedMonitorDialogClass::disInt10Check()
{
if (checkBox26->isChecked()) { checkBox25->setChecked(FALSE); }
}

void advancedMonitorDialogClass::accept()
{
QString empty = "MustBeEmpty";
if (checkBox25->isChecked()) { x->saveOption("Screen", sectNum, "InitPrimary", 1, empty); }
if (checkBox26->isChecked()) { x->saveOption("Screen", sectNum, "NoInt10", 1, empty); }
if (checkBox27->isChecked()) { x->saveOption("Screen", sectNum, "NoMTRR", 1, empty); }
if (checkBox28->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoCPUToScreenColorExpandFill", 1, empty); }
if (checkBox29->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoColor8x8PatternFillRect", 1, empty); }
if (checkBox30->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoColor8x8PatternFillTrap", 1, empty); }
if (checkBox31->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoDashedBresenhamLine", 1, empty); }
if (checkBox32->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoDashedTwoPointLine", 1, empty); }
if (checkBox33->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoImageWriteRect", 1, empty); }
if (checkBox34->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoMono8x8PatternFillRect", 1, empty); }
if (checkBox35->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoMono8x8PatternFillTrap", 1, empty); }
if (checkBox36->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoOffscreenPixmaps", 1, empty); }
if (checkBox37->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoPixmapCache", 1, empty); }
if (checkBox38->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoScanlineCPUToScreenColorExpandFill", 1, empty); }
if (checkBox40->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoScanlineImageWriteRect", 1, empty); }
if (checkBox41->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoScreenToScreenColorExpandFill", 1, empty); }
if (checkBox42->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoScreenToScreenCopy", 1, empty); }
if (checkBox43->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoSolidBresenhamLine", 1, empty); }
if (checkBox44->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoSolidFillRect", 1, empty); }
if (checkBox45->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoSolidFillTrap", 1, empty); }
if (checkBox46->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoSolidHorVertLine", 1, empty); }
if (checkBox47->isChecked()) { x->saveOption("Screen", sectNum, "XaaNoSolidTwoPointLine", 1, empty); }
if (checkBox24->isChecked()) { x->saveOption("Screen", sectNum, "Accel", 1, empty); }


if (checkBox23->isChecked())
{
if (kComboBox13->currentItem() == 0) { x->saveOptionNoBrackets("Screen", sectNum, "DefaultFbBpp", 1, "24"); }
if (kComboBox13->currentItem() == 1) { x->saveOptionNoBrackets("Screen", sectNum, "DefaultFbBpp", 1, "32"); }
}

if (groupBox2->isChecked())
{
x->saveOption("Screen", sectNum, "BiosLocation", 1, kLineEdit1->text());
}














close();

}














#include "advancedmonitordialogclass.moc"
